import { SecurityContext, Sanitizer, createPlatformFactory, COMPILER_OPTIONS, platformCore, Injectable, NgModule, ApplicationModule, RendererFactory2, ErrorHandler } from '@angular/core';
import { ɵplatformCoreDynamic } from '@angular/platform-browser-dynamic';
import { DOCUMENT } from '@angular/common';
import { ElementSchemaRegistry } from '@angular/compiler';
import { QMainWindow, QWidget, FlexLayout, QPushButton, QLabel, QCheckBox, QDial, QPixmap, QLineEdit, QPlainTextEdit, QRadioButton, QProgressBar, QScrollArea, QSpinBox } from '@nodegui/nodegui';
import { HttpBackend } from '@angular/common/http';
import { from } from 'rxjs';
import fetch from 'node-fetch';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NodeguiElementSchemaRegistry extends ElementSchemaRegistry {
    /**
     * @param {?} tagName
     * @param {?} propName
     * @return {?}
     */
    hasProperty(tagName, propName) {
        return true;
    }
    /**
     * @param {?} tagName
     * @param {?} schemaMetas
     * @return {?}
     */
    hasElement(tagName, schemaMetas) {
        return true;
    }
    /**
     * @param {?} propName
     * @return {?}
     */
    getMappedPropName(propName) {
        return propName;
    }
    /**
     * @return {?}
     */
    getDefaultComponentElementName() {
        return 'ng-component';
    }
    /**
     * @param {?} tagName
     * @param {?} propName
     * @return {?}
     */
    securityContext(tagName, propName) {
        return SecurityContext.NONE;
    }
    /**
     * @param {?} name
     * @return {?}
     */
    validateProperty(name) {
        return { error: false };
    }
    /**
     * @param {?} name
     * @return {?}
     */
    validateAttribute(name) {
        return { error: false };
    }
    /**
     * @return {?}
     */
    allKnownElementNames() {
        return [];
    }
    /**
     * @param {?} propName
     * @return {?}
     */
    normalizeAnimationStyleProperty(propName) {
        return propName;
    }
    /**
     * @param {?} camelCaseProp
     * @param {?} userProvidedProp
     * @param {?} val
     * @return {?}
     */
    normalizeAnimationStyleValue(camelCaseProp, userProvidedProp, val) {
        return { error: null, value: val.toString() };
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NodeguiSanitizer extends Sanitizer {
    /**
     * @param {?} context
     * @param {?} value
     * @return {?}
     */
    sanitize(context, value) {
        return value;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
const ɵ0 = {}, ɵ1 = {
    providers: [
        {
            provide: ElementSchemaRegistry,
            useClass: NodeguiElementSchemaRegistry,
            deps: []
        }
        // {
        //   provide: ResourceLoader,
        //   useClass: FileSystemResourceLoader,
        //   deps: []
        // }
    ]
};
/** @type {?} */
const platformNodeguiDynamic = createPlatformFactory(ɵplatformCoreDynamic, 'NodeguiDynamic', [
    { provide: DOCUMENT, useValue: ɵ0 },
    { provide: Sanitizer, useClass: NodeguiSanitizer, deps: [] },
    {
        provide: COMPILER_OPTIONS,
        useValue: ɵ1,
        multi: true
    }
]);

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
const ɵ0$1 = {}, ɵ1$1 = {
    providers: [
        {
            provide: ElementSchemaRegistry,
            useClass: NodeguiElementSchemaRegistry,
            deps: []
        }
    ]
};
/** @type {?} */
const platformNodeguiStatic = createPlatformFactory(platformCore, 'NodeguiStatic', [
    { provide: DOCUMENT, useValue: ɵ0$1 },
    { provide: Sanitizer, useClass: NodeguiSanitizer, deps: [] },
    {
        provide: COMPILER_OPTIONS,
        useValue: ɵ1$1,
        multi: true
    }
]);

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class QWindowService {
    constructor() {
        this.window = new QMainWindow();
        this.centralWidget = new QWidget();
        this.centralWidget.setObjectName('myroot');
    }
}
QWindowService.decorators = [
    { type: Injectable }
];
/** @nocollapse */
QWindowService.ctorParameters = () => [];
if (false) {
    /** @type {?} */
    QWindowService.prototype.window;
    /** @type {?} */
    QWindowService.prototype.rootLayout;
    /** @type {?} */
    QWindowService.prototype.centralWidget;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgWindow extends FlexLayout {
    /**
     * @param {?} newChild
     * @return {?}
     */
    appendChild(newChild) {
        this.addWidget(newChild);
    }
    /**
     * @param {?} newChild
     * @param {?} refChild
     * @return {?}
     */
    insertBefore(newChild, refChild) { }
    /**
     * @param {?} name
     * @param {?} value
     * @param {?=} namespace
     * @return {?}
     */
    setNgAttribute(name, value, namespace) {
        if (name === 'title') {
            this.parent.setWindowTitle(value);
        }
    }
    /**
     * @param {?} name
     * @param {?} value
     * @return {?}
     */
    setProperty(name, value) {
        throw new Error('Method not implemented.');
    }
    /**
     * @param {?} style
     * @param {?} value
     * @param {?=} flags
     * @return {?}
     */
    setStyle(style, value, flags) {
        throw new Error('Method not implemented.');
    }
    /**
     * @param {?} value
     * @return {?}
     */
    setValue(value) {
        throw new Error('Method not implemented.');
    }
    /**
     * @param {?} name
     * @param {?=} namespace
     * @return {?}
     */
    removeAttribute(name, namespace) {
        throw new Error('Method not implemented.');
    }
    /**
     * @param {?} oldChild
     * @return {?}
     */
    removeChild(oldChild) {
        throw new Error('Method not implemented.');
    }
    /**
     * @param {?} name
     * @return {?}
     */
    removeClass(name) {
        throw new Error('Method not implemented.');
    }
    /**
     * @param {?} style
     * @param {?=} flags
     * @return {?}
     */
    removeStyle(style, flags) {
        throw new Error('Method not implemented.');
    }
}
NgWindow.nodeName = 'window';
if (false) {
    /** @type {?} */
    NgWindow.nodeName;
    /** @type {?} */
    NgWindow.prototype.parent;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class TextField extends QWidget {
    /**
     * @param {?} value
     */
    constructor(value) {
        super();
        this.value = value;
    }
    /**
     * @param {?} value
     * @return {?}
     */
    setValue(value) {
        this.parent.setText(value);
    }
}
if (false) {
    /** @type {?} */
    TextField.prototype.parent;
    /** @type {?} */
    TextField.prototype.value;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgButton extends QPushButton {
    /**
     * @param {?} newChild
     * @return {?}
     */
    appendChild(newChild) {
        if (newChild instanceof TextField) {
            newChild.parent = this;
            this.setText(newChild.value);
        }
        else {
            console.warn('Button may be appendChild only TextField');
        }
    }
    /**
     * @param {?} newChild
     * @param {?} refChild
     * @return {?}
     */
    insertBefore(newChild, refChild) { }
    /**
     * @param {?} name
     * @param {?} value
     * @param {?=} namespace
     * @return {?}
     */
    setNgAttribute(name, value, namespace) { }
    /**
     * @param {?} name
     * @param {?} value
     * @return {?}
     */
    setProperty(name, value) {
        switch (name) {
            case 'enabled':
                this.setEnabled((/** @type {?} */ (value)));
                break;
            case 'flat':
                this.setFlat((/** @type {?} */ (value)));
                break;
            default:
                break;
        }
    }
    /**
     * @param {?} style
     * @param {?} value
     * @param {?=} flags
     * @return {?}
     */
    setStyle(style, value, flags) {
        this.setInlineStyle(`${style}:${value}`);
    }
    /**
     * @param {?} value
     * @return {?}
     */
    setValue(value) {
        this.setText(value);
    }
    /**
     * @param {?} name
     * @param {?=} namespace
     * @return {?}
     */
    removeAttribute(name, namespace) {
        throw new Error('Method not implemented.');
    }
    /**
     * @param {?} oldChild
     * @return {?}
     */
    removeChild(oldChild) {
        throw new Error('Method not implemented.');
    }
    /**
     * @param {?} name
     * @return {?}
     */
    removeClass(name) {
        throw new Error('Method not implemented.');
    }
    /**
     * @param {?} style
     * @param {?=} flags
     * @return {?}
     */
    removeStyle(style, flags) {
        throw new Error('Method not implemented.');
    }
}
NgButton.nodeName = 'button';
if (false) {
    /** @type {?} */
    NgButton.nodeName;
    /** @type {?} */
    NgButton.prototype.parent;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgText extends QLabel {
    /**
     * @param {?} newChild
     * @return {?}
     */
    appendChild(newChild) {
        if (newChild instanceof TextField) {
            newChild.parent = this;
            this.setText(newChild.value);
        }
        else {
            console.warn('Text may be appendChild only TextField');
        }
    }
    /**
     * @param {?} newChild
     * @param {?} refChild
     * @return {?}
     */
    insertBefore(newChild, refChild) { }
    /**
     * @param {?} name
     * @param {?} value
     * @param {?=} namespace
     * @return {?}
     */
    setNgAttribute(name, value, namespace) { }
    /**
     * @param {?} name
     * @param {?} value
     * @return {?}
     */
    setProperty(name, value) {
        throw new Error('Method not implemented.');
    }
    /**
     * @param {?} style
     * @param {?} value
     * @param {?=} flags
     * @return {?}
     */
    setStyle(style, value, flags) {
        this.setInlineStyle(`${style}:${value}`);
    }
    /**
     * @param {?} value
     * @return {?}
     */
    setValue(value) {
        this.setText(value);
    }
    /**
     * @param {?} name
     * @param {?=} namespace
     * @return {?}
     */
    removeAttribute(name, namespace) {
        throw new Error('Method not implemented.');
    }
    /**
     * @param {?} oldChild
     * @return {?}
     */
    removeChild(oldChild) {
        throw new Error('Method not implemented.');
    }
    /**
     * @param {?} name
     * @return {?}
     */
    removeClass(name) {
        throw new Error('Method not implemented.');
    }
    /**
     * @param {?} style
     * @param {?=} flags
     * @return {?}
     */
    removeStyle(style, flags) {
        throw new Error('Method not implemented.');
    }
}
NgText.nodeName = 'text';
if (false) {
    /** @type {?} */
    NgText.nodeName;
    /** @type {?} */
    NgText.prototype.parent;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgView extends QWidget {
    /**
     * @param {?} newChild
     * @return {?}
     */
    appendChild(newChild) {
        if (!newChild) {
            return;
        }
        if (!this.layout) {
            /** @type {?} */
            const flexLayout = new FlexLayout();
            flexLayout.setFlexNode(this.getFlexNode());
            this.setLayout(flexLayout);
            this.layout = flexLayout;
        }
        this.layout.addWidget(newChild);
    }
    /**
     * @param {?} newChild
     * @param {?} refChild
     * @return {?}
     */
    insertBefore(newChild, refChild) {
        if (!this.layout) {
            console.warn('parent has no layout to insert child before another child');
            return;
        }
        ((/** @type {?} */ (this.layout))).insertChildBefore(newChild, this);
    }
    /**
     * @param {?} name
     * @param {?} value
     * @param {?=} namespace
     * @return {?}
     */
    setNgAttribute(name, value, namespace) {
        switch (name) {
            case 'id':
                this.setObjectName(value);
                break;
            default:
                break;
        }
    }
    /**
     * @param {?} name
     * @param {?} value
     * @return {?}
     */
    setProperty(name, value) {
        throw new Error('Method not implemented.');
    }
    /**
     * @param {?} style
     * @param {?} value
     * @param {?=} flags
     * @return {?}
     */
    setStyle(style, value, flags) {
        this.setInlineStyle(`${style}:${value}`);
    }
    /**
     * @param {?} value
     * @return {?}
     */
    setValue(value) {
        throw new Error('Method not implemented.');
    }
    /**
     * @param {?} name
     * @param {?=} namespace
     * @return {?}
     */
    removeAttribute(name, namespace) {
        throw new Error('Method not implemented.');
    }
    /**
     * @param {?} oldChild
     * @return {?}
     */
    removeChild(oldChild) {
        throw new Error('Method not implemented.');
    }
    /**
     * @param {?} name
     * @return {?}
     */
    removeClass(name) {
        throw new Error('Method not implemented.');
    }
    /**
     * @param {?} style
     * @param {?=} flags
     * @return {?}
     */
    removeStyle(style, flags) {
        throw new Error('Method not implemented.');
    }
}
NgView.nodeName = 'view';
if (false) {
    /** @type {?} */
    NgView.nodeName;
    /** @type {?} */
    NgView.prototype.parent;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgCheckbox extends QCheckBox {
    /**
     * @param {?} newChild
     * @return {?}
     */
    appendChild(newChild) {
        if (newChild instanceof TextField) {
            newChild.parent = this;
            this.setText(newChild.value);
        }
        else {
            console.warn('checkbox may be appendChild only TextField');
        }
    }
    /**
     * @param {?} newChild
     * @param {?} refChild
     * @return {?}
     */
    insertBefore(newChild, refChild) { }
    /**
     * @param {?} name
     * @param {?} value
     * @param {?=} namespace
     * @return {?}
     */
    setNgAttribute(name, value, namespace) { }
    /**
     * @param {?} name
     * @param {?} value
     * @return {?}
     */
    setProperty(name, value) {
        switch (name) {
            case 'checked':
                this.setChecked(value);
                break;
            case 'enabled':
                this.setEnabled(value);
                break;
            default:
                break;
        }
    }
    /**
     * @param {?} style
     * @param {?} value
     * @param {?=} flags
     * @return {?}
     */
    setStyle(style, value, flags) {
        this.setInlineStyle(`${style}:${value}`);
    }
    /**
     * @param {?} value
     * @return {?}
     */
    setValue(value) {
        this.setText(value);
    }
    /**
     * @param {?} name
     * @param {?=} namespace
     * @return {?}
     */
    removeAttribute(name, namespace) {
        throw new Error('Method not implemented.');
    }
    /**
     * @param {?} oldChild
     * @return {?}
     */
    removeChild(oldChild) {
        throw new Error('Method not implemented.');
    }
    /**
     * @param {?} name
     * @return {?}
     */
    removeClass(name) {
        throw new Error('Method not implemented.');
    }
    /**
     * @param {?} style
     * @param {?=} flags
     * @return {?}
     */
    removeStyle(style, flags) {
        throw new Error('Method not implemented.');
    }
}
NgCheckbox.nodeName = 'checkbox';
if (false) {
    /** @type {?} */
    NgCheckbox.nodeName;
    /** @type {?} */
    NgCheckbox.prototype.parent;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgDial extends QDial {
    /**
     * @param {?} newChild
     * @return {?}
     */
    appendChild(newChild) {
        console.warn('dial do not have append child');
    }
    /**
     * @param {?} newChild
     * @param {?} refChild
     * @return {?}
     */
    insertBefore(newChild, refChild) { }
    /**
     * @param {?} name
     * @param {?} value
     * @param {?=} namespace
     * @return {?}
     */
    setNgAttribute(name, value, namespace) { }
    /**
     * @param {?} name
     * @param {?} value
     * @return {?}
     */
    setProperty(name, value) {
        switch (name) {
            case 'enabled':
                this.setEnabled((/** @type {?} */ (value)));
                break;
            case 'notchesVisible':
                this.setNotchesVisible((/** @type {?} */ (value)));
                break;
            case 'wrapping':
                this.setWrapping((/** @type {?} */ (value)));
                break;
            case 'notchTarget':
                this.setNotchTarget((/** @type {?} */ (value)));
                break;
            default:
                break;
        }
    }
    /**
     * @param {?} style
     * @param {?} value
     * @param {?=} flags
     * @return {?}
     */
    setStyle(style, value, flags) {
        this.setInlineStyle(`${style}:${value}`);
    }
    /**
     * @param {?} value
     * @return {?}
     */
    setValue(value) { }
    /**
     * @param {?} name
     * @param {?=} namespace
     * @return {?}
     */
    removeAttribute(name, namespace) {
        throw new Error('Method not implemented.');
    }
    /**
     * @param {?} oldChild
     * @return {?}
     */
    removeChild(oldChild) {
        throw new Error('Method not implemented.');
    }
    /**
     * @param {?} name
     * @return {?}
     */
    removeClass(name) {
        throw new Error('Method not implemented.');
    }
    /**
     * @param {?} style
     * @param {?=} flags
     * @return {?}
     */
    removeStyle(style, flags) {
        throw new Error('Method not implemented.');
    }
}
NgDial.nodeName = 'dial';
if (false) {
    /** @type {?} */
    NgDial.nodeName;
    /** @type {?} */
    NgDial.prototype.parent;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgImage extends QLabel {
    /**
     * @param {?} newChild
     * @return {?}
     */
    appendChild(newChild) {
        console.warn('image not supported appendChild');
    }
    /**
     * @param {?} newChild
     * @param {?} refChild
     * @return {?}
     */
    insertBefore(newChild, refChild) { }
    /**
     * @param {?} name
     * @param {?} value
     * @param {?=} namespace
     * @return {?}
     */
    setNgAttribute(name, value, namespace) { }
    /**
     * @param {?} name
     * @param {?} value
     * @return {?}
     */
    setProperty(name, value) {
        switch (name) {
            case 'enabled':
                this.setEnabled((/** @type {?} */ (value)));
                break;
            case 'src':
                if (!value) {
                    return;
                }
                /** @type {?} */
                const pixMap = new QPixmap((/** @type {?} */ (value)));
                this.setPixmap(pixMap);
                /** @type {?} */
                const size = this.size();
                this.scalePixmap(size.width, size.height);
                break;
            case 'aspectRatioMode':
                this.setAspectRatioMode((/** @type {?} */ (value)));
                break;
            default:
                break;
        }
    }
    /**
     * @param {?} style
     * @param {?} value
     * @param {?=} flags
     * @return {?}
     */
    setStyle(style, value, flags) {
        this.setInlineStyle(`${style}:${value}`);
    }
    /**
     * @param {?} value
     * @return {?}
     */
    setValue(value) {
        this.setText(value);
    }
    /**
     * @param {?} mode
     * @return {?}
     */
    setAspectRatioMode(mode) {
        this.aspectRatioMode = mode;
    }
    /**
     * @param {?} width
     * @param {?} height
     * @return {?}
     */
    scalePixmap(width, height) {
        if (this.originalPixmap) {
            return super.setPixmap(this.originalPixmap.scaled(width, height, this.aspectRatioMode));
        }
    }
    /**
     * @param {?} pixmap
     * @return {?}
     */
    setPixmap(pixmap) {
        super.setPixmap(pixmap);
        this.originalPixmap = pixmap;
    }
    /**
     * @param {?} name
     * @param {?=} namespace
     * @return {?}
     */
    removeAttribute(name, namespace) {
        throw new Error('Method not implemented.');
    }
    /**
     * @param {?} oldChild
     * @return {?}
     */
    removeChild(oldChild) {
        throw new Error('Method not implemented.');
    }
    /**
     * @param {?} name
     * @return {?}
     */
    removeClass(name) {
        throw new Error('Method not implemented.');
    }
    /**
     * @param {?} style
     * @param {?=} flags
     * @return {?}
     */
    removeStyle(style, flags) {
        throw new Error('Method not implemented.');
    }
}
NgImage.nodeName = 'image';
if (false) {
    /** @type {?} */
    NgImage.nodeName;
    /** @type {?} */
    NgImage.prototype.parent;
    /** @type {?} */
    NgImage.prototype.originalPixmap;
    /** @type {?} */
    NgImage.prototype.aspectRatioMode;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgLineEdit extends QLineEdit {
    /**
     * @param {?} newChild
     * @return {?}
     */
    appendChild(newChild) {
        throw new Error('Method not implemented.');
    }
    /**
     * @param {?} newChild
     * @param {?} refChild
     * @return {?}
     */
    insertBefore(newChild, refChild) { }
    /**
     * @param {?} name
     * @param {?} value
     * @param {?=} namespace
     * @return {?}
     */
    setNgAttribute(name, value, namespace) { }
    /**
     * @param {?} name
     * @param {?} value
     * @return {?}
     */
    setProperty(name, value) {
        switch (name) {
            case 'text':
                value ? this.setText((/** @type {?} */ (value))) : this.clear();
                break;
            case 'placeholderText':
                this.setPlaceholderText((/** @type {?} */ (value)));
                break;
            case 'readOnly':
                this.setReadOnly((/** @type {?} */ (value)));
                break;
            default:
                break;
        }
    }
    /**
     * @param {?} style
     * @param {?} value
     * @param {?=} flags
     * @return {?}
     */
    setStyle(style, value, flags) {
        this.setInlineStyle(`${style}:${value}`);
    }
    /**
     * @param {?} value
     * @return {?}
     */
    setValue(value) {
        this.setText(value);
    }
    /**
     * @param {?} name
     * @param {?=} namespace
     * @return {?}
     */
    removeAttribute(name, namespace) {
        throw new Error('Method not implemented.');
    }
    /**
     * @param {?} oldChild
     * @return {?}
     */
    removeChild(oldChild) {
        throw new Error('Method not implemented.');
    }
    /**
     * @param {?} name
     * @return {?}
     */
    removeClass(name) {
        throw new Error('Method not implemented.');
    }
    /**
     * @param {?} style
     * @param {?=} flags
     * @return {?}
     */
    removeStyle(style, flags) {
        throw new Error('Method not implemented.');
    }
}
NgLineEdit.nodeName = 'linedit';
if (false) {
    /** @type {?} */
    NgLineEdit.nodeName;
    /** @type {?} */
    NgLineEdit.prototype.parent;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgPlainTextEdit extends QPlainTextEdit {
    /**
     * @param {?} newChild
     * @return {?}
     */
    appendChild(newChild) {
        console.warn('plaintextedit do not have append child');
    }
    /**
     * @param {?} newChild
     * @param {?} refChild
     * @return {?}
     */
    insertBefore(newChild, refChild) { }
    /**
     * @param {?} name
     * @param {?} value
     * @param {?=} namespace
     * @return {?}
     */
    setNgAttribute(name, value, namespace) { }
    /**
     * @param {?} name
     * @param {?} value
     * @return {?}
     */
    setProperty(name, value) {
        switch (name) {
            case 'text':
                value ? this.setPlainText((/** @type {?} */ (value))) : this.clear();
                break;
            case 'placeholderText':
                this.setPlaceholderText((/** @type {?} */ (value)));
                break;
            case 'readOnly':
                this.setReadOnly((/** @type {?} */ (value)));
                break;
            default:
                break;
        }
    }
    /**
     * @param {?} style
     * @param {?} value
     * @param {?=} flags
     * @return {?}
     */
    setStyle(style, value, flags) {
        this.setInlineStyle(`${style}:${value}`);
    }
    /**
     * @param {?} value
     * @return {?}
     */
    setValue(value) {
        throw new Error('Method not implemented.');
    }
    /**
     * @param {?} name
     * @param {?=} namespace
     * @return {?}
     */
    removeAttribute(name, namespace) {
        throw new Error('Method not implemented.');
    }
    /**
     * @param {?} oldChild
     * @return {?}
     */
    removeChild(oldChild) {
        throw new Error('Method not implemented.');
    }
    /**
     * @param {?} name
     * @return {?}
     */
    removeClass(name) {
        throw new Error('Method not implemented.');
    }
    /**
     * @param {?} style
     * @param {?=} flags
     * @return {?}
     */
    removeStyle(style, flags) {
        throw new Error('Method not implemented.');
    }
}
NgPlainTextEdit.nodeName = 'plaintextedit';
if (false) {
    /** @type {?} */
    NgPlainTextEdit.nodeName;
    /** @type {?} */
    NgPlainTextEdit.prototype.parent;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgRadioButton extends QRadioButton {
    /**
     * @param {?} newChild
     * @return {?}
     */
    appendChild(newChild) {
        console.warn('radiobutton do not have append child');
    }
    /**
     * @param {?} newChild
     * @param {?} refChild
     * @return {?}
     */
    insertBefore(newChild, refChild) { }
    /**
     * @param {?} name
     * @param {?} value
     * @param {?=} namespace
     * @return {?}
     */
    setNgAttribute(name, value, namespace) { }
    /**
     * @param {?} name
     * @param {?} value
     * @return {?}
     */
    setProperty(name, value) {
        switch (name) {
            case 'text':
                this.setText((/** @type {?} */ (value)));
                break;
            case 'enabled':
                this.setEnabled((/** @type {?} */ (value)));
                break;
            default:
                break;
        }
    }
    /**
     * @param {?} style
     * @param {?} value
     * @param {?=} flags
     * @return {?}
     */
    setStyle(style, value, flags) {
        this.setInlineStyle(`${style}:${value}`);
    }
    /**
     * @param {?} value
     * @return {?}
     */
    setValue(value) {
        this.setText(value);
    }
    /**
     * @param {?} name
     * @param {?=} namespace
     * @return {?}
     */
    removeAttribute(name, namespace) {
        throw new Error('Method not implemented.');
    }
    /**
     * @param {?} oldChild
     * @return {?}
     */
    removeChild(oldChild) {
        throw new Error('Method not implemented.');
    }
    /**
     * @param {?} name
     * @return {?}
     */
    removeClass(name) {
        throw new Error('Method not implemented.');
    }
    /**
     * @param {?} style
     * @param {?=} flags
     * @return {?}
     */
    removeStyle(style, flags) {
        throw new Error('Method not implemented.');
    }
}
NgRadioButton.nodeName = 'radiobutton';
if (false) {
    /** @type {?} */
    NgRadioButton.nodeName;
    /** @type {?} */
    NgRadioButton.prototype.parent;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgProgressBar extends QProgressBar {
    /**
     * @param {?} newChild
     * @return {?}
     */
    appendChild(newChild) {
        console.warn('progressbar do not have append child');
    }
    /**
     * @param {?} newChild
     * @param {?} refChild
     * @return {?}
     */
    insertBefore(newChild, refChild) { }
    /**
     * @param {?} name
     * @param {?} value
     * @param {?=} namespace
     * @return {?}
     */
    setNgAttribute(name, value, namespace) { }
    /**
     * @param {?} name
     * @param {?} value
     * @return {?}
     */
    setProperty(name, value) {
        switch (name) {
            case 'value':
                this.setValue(value);
                break;
            case 'minimum':
                this.setMinimum(value);
                break;
            case 'maximum':
                this.setMaximum(value);
                break;
            case 'orientation':
                this.setOrientation(value);
                break;
            case 'enabled':
                this.setEnabled(value);
                break;
            default:
                break;
        }
    }
    /**
     * @param {?} style
     * @param {?} value
     * @param {?=} flags
     * @return {?}
     */
    setStyle(style, value, flags) {
        this.setInlineStyle(`${style}:${value}`);
    }
    /**
     * @param {?} value
     * @return {?}
     */
    setValue(value) {
        super.setValue(value);
    }
    /**
     * @param {?} name
     * @param {?=} namespace
     * @return {?}
     */
    removeAttribute(name, namespace) {
        throw new Error('Method not implemented.');
    }
    /**
     * @param {?} oldChild
     * @return {?}
     */
    removeChild(oldChild) {
        throw new Error('Method not implemented.');
    }
    /**
     * @param {?} name
     * @return {?}
     */
    removeClass(name) {
        throw new Error('Method not implemented.');
    }
    /**
     * @param {?} style
     * @param {?=} flags
     * @return {?}
     */
    removeStyle(style, flags) {
        throw new Error('Method not implemented.');
    }
}
NgProgressBar.nodeName = 'progressbar';
if (false) {
    /** @type {?} */
    NgProgressBar.nodeName;
    /** @type {?} */
    NgProgressBar.prototype.parent;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgScrollArea extends QScrollArea {
    /**
     * @param {?} newChild
     * @return {?}
     */
    appendChild(newChild) {
        throw new Error('Method not implemented.');
    }
    /**
     * @param {?} newChild
     * @param {?} refChild
     * @return {?}
     */
    insertBefore(newChild, refChild) { }
    /**
     * @param {?} name
     * @param {?} value
     * @param {?=} namespace
     * @return {?}
     */
    setNgAttribute(name, value, namespace) { }
    /**
     * @param {?} name
     * @param {?} value
     * @return {?}
     */
    setProperty(name, value) {
        switch (name) {
            case 'enabled':
                this.setEnabled((/** @type {?} */ (value)));
                break;
            default:
                break;
        }
    }
    /**
     * @param {?} style
     * @param {?} value
     * @param {?=} flags
     * @return {?}
     */
    setStyle(style, value, flags) {
        this.setInlineStyle(`${style}:${value}`);
    }
    /**
     * @param {?} value
     * @return {?}
     */
    setValue(value) { }
    /**
     * @param {?} name
     * @param {?=} namespace
     * @return {?}
     */
    removeAttribute(name, namespace) {
        throw new Error('Method not implemented.');
    }
    /**
     * @param {?} oldChild
     * @return {?}
     */
    removeChild(oldChild) {
        throw new Error('Method not implemented.');
    }
    /**
     * @param {?} name
     * @return {?}
     */
    removeClass(name) {
        throw new Error('Method not implemented.');
    }
    /**
     * @param {?} style
     * @param {?=} flags
     * @return {?}
     */
    removeStyle(style, flags) {
        throw new Error('Method not implemented.');
    }
}
NgScrollArea.nodeName = 'scrollarea';
if (false) {
    /** @type {?} */
    NgScrollArea.nodeName;
    /** @type {?} */
    NgScrollArea.prototype.parent;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function Range() { }
if (false) {
    /** @type {?} */
    Range.prototype.minimum;
    /** @type {?} */
    Range.prototype.maximum;
}
class NgSpinnBox extends QSpinBox {
    /**
     * @param {?} newChild
     * @return {?}
     */
    appendChild(newChild) {
        throw new Error('Method not implemented.');
    }
    /**
     * @param {?} newChild
     * @param {?} refChild
     * @return {?}
     */
    insertBefore(newChild, refChild) { }
    /**
     * @param {?} name
     * @param {?} value
     * @param {?=} namespace
     * @return {?}
     */
    setNgAttribute(name, value, namespace) { }
    /**
     * @param {?} name
     * @param {?} value
     * @return {?}
     */
    setProperty(name, value) {
        switch (name) {
            case 'prefix':
                this.setPrefix((/** @type {?} */ (value)));
                break;
            case 'suffix':
                this.setSuffix((/** @type {?} */ (value)));
                break;
            case 'singleStep':
                this.setSingleStep((/** @type {?} */ (value)));
                break;
            case 'range':
                this.setRange(((/** @type {?} */ (value))).minimum, ((/** @type {?} */ (value))).maximum);
                break;
            case 'value':
                this.setValue((/** @type {?} */ (value)));
                break;
            default:
                break;
        }
    }
    /**
     * @param {?} style
     * @param {?} value
     * @param {?=} flags
     * @return {?}
     */
    setStyle(style, value, flags) {
        this.setInlineStyle(`${style}:${value}`);
    }
    /**
     * @param {?} value
     * @return {?}
     */
    setValue(value) {
        super.setValue(value);
    }
    /**
     * @param {?} name
     * @param {?=} namespace
     * @return {?}
     */
    removeAttribute(name, namespace) {
        throw new Error('Method not implemented.');
    }
    /**
     * @param {?} oldChild
     * @return {?}
     */
    removeChild(oldChild) {
        throw new Error('Method not implemented.');
    }
    /**
     * @param {?} name
     * @return {?}
     */
    removeClass(name) {
        throw new Error('Method not implemented.');
    }
    /**
     * @param {?} style
     * @param {?=} flags
     * @return {?}
     */
    removeStyle(style, flags) {
        throw new Error('Method not implemented.');
    }
}
NgSpinnBox.nodeName = 'spinbox';
if (false) {
    /** @type {?} */
    NgSpinnBox.nodeName;
    /** @type {?} */
    NgSpinnBox.prototype.parent;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ComponentsMap {
    constructor() {
        this.map = new Map();
        this.map.set(NgButton.nodeName, NgButton);
        this.map.set(NgWindow.nodeName, NgWindow);
        this.map.set(NgText.nodeName, NgText);
        this.map.set(NgView.nodeName, NgView);
        this.map.set(NgCheckbox.nodeName, NgCheckbox);
        this.map.set(NgDial.nodeName, NgDial);
        this.map.set(NgImage.nodeName, NgImage);
        this.map.set(NgLineEdit.nodeName, NgLineEdit);
        this.map.set(NgPlainTextEdit.nodeName, NgPlainTextEdit);
        this.map.set(NgRadioButton.nodeName, NgRadioButton);
        this.map.set(NgProgressBar.nodeName, NgProgressBar);
        this.map.set(NgScrollArea.nodeName, NgScrollArea);
        this.map.set(NgSpinnBox.nodeName, NgSpinnBox);
    }
}
ComponentsMap.decorators = [
    { type: Injectable }
];
/** @nocollapse */
ComponentsMap.ctorParameters = () => [];
if (false) {
    /** @type {?} */
    ComponentsMap.prototype.map;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NodeguiRendererFactory {
    /**
     * @param {?} windowService
     * @param {?} components
     */
    constructor(windowService, components) {
        this.windowService = windowService;
        this.renderer = new NodeguiRenderer(windowService, components);
    }
    /**
     * @return {?}
     */
    end() {
        this.windowService.window.show();
    }
    /**
     * @param {?} hostElement
     * @param {?} type
     * @return {?}
     */
    createRenderer(hostElement, type) {
        if (type) {
            hostElement.setStyleSheet(type.styles);
        }
        return this.renderer;
    }
}
NodeguiRendererFactory.decorators = [
    { type: Injectable }
];
/** @nocollapse */
NodeguiRendererFactory.ctorParameters = () => [
    { type: QWindowService },
    { type: ComponentsMap }
];
if (false) {
    /**
     * @type {?}
     * @protected
     */
    NodeguiRendererFactory.prototype.renderer;
    /**
     * @type {?}
     * @private
     */
    NodeguiRendererFactory.prototype.windowService;
}
class NodeguiRenderer {
    /**
     * @param {?} window
     * @param {?} components
     */
    constructor(window, components) {
        this.window = window;
        this.componentsMap = components.map;
    }
    /**
     * @param {?} name
     * @param {?=} namespace
     * @return {?}
     */
    createElement(name, namespace) {
        /** @type {?} */
        const Component = this.componentsMap.get(name);
        if (Component) {
            return new Component();
        }
        else {
            /** @type {?} */
            const widget = new NgView();
            widget.setObjectName(name);
            return widget;
        }
    }
    /**
     * @param {?} value
     * @return {?}
     */
    createText(value) {
        return new TextField(value);
    }
    /**
     * @return {?}
     */
    selectRootElement() {
        return this.window.window;
    }
    /**
     * @param {?} el
     * @param {?} name
     * @return {?}
     */
    addClass(el, name) {
        console.log(el, name);
    }
    /**
     * @param {?} parent
     * @param {?} newChild
     * @return {?}
     */
    appendChild(parent, newChild) {
        if (newChild) {
            if (parent instanceof QMainWindow && newChild instanceof NgWindow) {
                newChild.parent = parent;
                this.window.centralWidget.setLayout(newChild);
                this.window.window.setCentralWidget(this.window.centralWidget);
            }
            else {
                parent.appendChild(newChild);
            }
        }
    }
    /**
     * @param {?} value
     * @return {?}
     */
    createComment(value) { }
    /**
     * @return {?}
     */
    destroy() { }
    /**
     * @param {?} parent
     * @param {?} newChild
     * @param {?} refChild
     * @return {?}
     */
    insertBefore(parent, newChild, refChild) {
        parent.insertBefore(newChild, refChild);
    }
    /**
     * @param {?} target
     * @param {?} eventName
     * @param {?} callback
     * @return {?}
     */
    listen(target, eventName, callback) {
        /** @type {?} */
        const callbackFunc = (/**
         * @param {?} e
         * @return {?}
         */
        (e) => callback.call(target, e));
        target.addEventListener(eventName, callbackFunc);
        return (/**
         * @return {?}
         */
        () => target.removeEventListener(eventName, callbackFunc));
    }
    /**
     * @param {?} node
     * @return {?}
     */
    nextSibling(node) {
        console.log('nextSibling');
    }
    /**
     * @param {?} node
     * @return {?}
     */
    parentNode(node) { }
    /**
     * @param {?} el
     * @param {?} name
     * @param {?=} namespace
     * @return {?}
     */
    removeAttribute(el, name, namespace) {
        el.removeAttribute(name, namespace);
    }
    /**
     * @param {?} parent
     * @param {?} oldChild
     * @return {?}
     */
    removeChild(parent, oldChild) {
        parent.removeChild(oldChild);
    }
    /**
     * @param {?} el
     * @param {?} name
     * @return {?}
     */
    removeClass(el, name) {
        el.removeClass(name);
    }
    /**
     * @param {?} el
     * @param {?} style
     * @param {?=} flags
     * @return {?}
     */
    removeStyle(el, style, flags) {
        el.removeStyle(style, flags);
    }
    /**
     * @param {?} el
     * @param {?} name
     * @param {?} value
     * @param {?=} namespace
     * @return {?}
     */
    setAttribute(el, name, value, namespace) {
        if (el instanceof QMainWindow) {
            console.log(`${QMainWindow.name} name = ${value}`);
        }
        else {
            el.setNgAttribute(name, value, namespace);
        }
    }
    /**
     * @param {?} el
     * @param {?} name
     * @param {?} value
     * @return {?}
     */
    setProperty(el, name, value) {
        el.setProperty(name, value);
    }
    /**
     * @param {?} el
     * @param {?} style
     * @param {?} value
     * @param {?=} flags
     * @return {?}
     */
    setStyle(el, style, value, flags) {
        console.log('setStyle', style);
        el.setStyle(style, value, flags);
    }
    /**
     * @param {?} node
     * @param {?} value
     * @return {?}
     */
    setValue(node, value) {
        node.setValue(value);
    }
}
if (false) {
    /** @type {?} */
    NodeguiRenderer.prototype.data;
    /** @type {?} */
    NodeguiRenderer.prototype.componentsMap;
    /** @type {?} */
    NodeguiRenderer.prototype.destroyNode;
    /**
     * @type {?}
     * @private
     */
    NodeguiRenderer.prototype.window;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NodeguiErrorHandler {
    /**
     * @param {?} error
     * @return {?}
     */
    handleError(error) {
        console.error(error.message, error.stack);
    }
}
NodeguiErrorHandler.decorators = [
    { type: Injectable }
];
class NodeguiLibModule {
}
NodeguiLibModule.decorators = [
    { type: NgModule, args: [{
                exports: [ApplicationModule],
                providers: [
                    QWindowService,
                    ComponentsMap,
                    {
                        provide: RendererFactory2,
                        useClass: NodeguiRendererFactory,
                        deps: [QWindowService, ComponentsMap]
                    },
                    { provide: ErrorHandler, useClass: NodeguiErrorHandler }
                ]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @param {?} strMap
 * @return {?}
 */
function strMapToObj(strMap) {
    /** @type {?} */
    const obj = Object.create(null);
    for (const [k, v] of strMap.headers) {
        obj[k] = v;
    }
    return obj;
}
class HttpFetchBackend extends HttpBackend {
    /**
     * @param {?} req
     * @return {?}
     */
    handle(req) {
        return from(fetch(req.url, {
            method: req.method,
            cache: 'no-cache',
            credentials: req.withCredentials ? 'same-origin' : undefined,
            headers: req.headers ? strMapToObj(req.headers) : undefined,
            body: req.body ? JSON.stringify(req.body) : undefined
        }).then((/**
         * @param {?} res
         * @return {?}
         */
        res => res.json())));
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { HttpFetchBackend, NodeguiErrorHandler, NodeguiLibModule, platformNodeguiDynamic, platformNodeguiStatic, NodeguiSanitizer as ɵa, NodeguiElementSchemaRegistry as ɵb, QWindowService as ɵc, ComponentsMap as ɵd, NodeguiRendererFactory as ɵe };
//# sourceMappingURL=angular-nodegui.js.map
